#ifndef __WatchingSysDefsH
#define __WatchingSysDefsH

// This file is an ugly hack.
// Usage:
// You include it in your main project source file, after the
// hdrstop but before any of the USEFORM statements.
// It hijacks the USEFORM macro replacing it with this one
// Where before you had USEFORM(unitname,formname)
// and it did the stuff in sysdefs.h, now it does the stuff below.
// We statically declare a TScrSysDefsRegisterClass so that, in its
// constructor, it registers the class.
// Intent:
// The BCB ide itself manages and keeps up to date the USEFORM... block
// of code at the beginning of the project. With this hack in place,
// we get the ide to also manage our RegisterClass stuff as well.
// Therefore, by the time the program is run, every single Form class
// has been registered (and so can be got by GetClass later on).
// This is so that we can store property names.


class TWatchingSysDefsRegisterClass
{ public:
  TWatchingSysDefsRegisterClass(TMetaClass *m) {RegisterClass(m);}
};
#ifdef USEFORM
#undef USEFORM
#endif
#define USEFORM(FileName,FormName) \
    class DELPHICLASS T##FormName;       \
    extern PACKAGE T##FormName *FormName; \
    TWatchingSysDefsRegisterClass dummy##FormName(__classid(T##FormName));


#endif